Clarify the need for QuickCheck/Haskell tests
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Use bash in order to be able to use pipefail
13 SHELL=/bin/bash
14
15 ACLOCAL_AMFLAGS = -I autotools
16 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
17 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
18 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
19 CHECK_MAN = $(top_srcdir)/autotools/check-man
20 CHECK_VERSION = $(top_srcdir)/autotools/check-version
21 CHECK_NEWS = $(top_srcdir)/autotools/check-news
22 DOCPP = $(top_srcdir)/autotools/docpp
23 REPLACE_VARS_SED = autotools/replace_vars.sed
24
25 # Note: these are automake-specific variables, and must be named after
26 # the directory + 'dir' suffix
27 clientdir = $(pkgpythondir)/client
28 hypervisordir = $(pkgpythondir)/hypervisor
29 httpdir = $(pkgpythondir)/http
30 masterddir = $(pkgpythondir)/masterd
31 confddir = $(pkgpythondir)/confd
32 rapidir = $(pkgpythondir)/rapi
33 serverdir = $(pkgpythondir)/server
34 watcherdir = $(pkgpythondir)/watcher
35 impexpddir = $(pkgpythondir)/impexpd
36 utilsdir = $(pkgpythondir)/utils
37 toolsdir = $(pkglibdir)/tools
38 iallocatorsdir = $(pkglibdir)/iallocators
39 pytoolsdir = $(pkgpythondir)/tools
40 docdir = $(datadir)/doc/$(PACKAGE)
41
42 # Delete output file if an error occurred while building it
43 .DELETE_ON_ERROR:
44
45 HTOOLS_DIRS = \
46         htools \
47         htools/Ganeti \
48         htools/Ganeti/HTools
49
50 DIRS = \
51         autotools \
52         daemons \
53         devel \
54         doc \
55         doc/examples \
56         doc/examples/hooks \
57         doc/examples/gnt-debug \
58         $(HTOOLS_DIRS) \
59         lib \
60         lib/client \
61         lib/build \
62         lib/confd \
63         lib/http \
64         lib/hypervisor \
65         lib/impexpd \
66         lib/masterd \
67         lib/rapi \
68         lib/server \
69         lib/tools \
70         lib/utils \
71         lib/watcher \
72         man \
73         qa \
74         test \
75         test/data \
76         tools
77
78 BUILDTIME_DIR_AUTOCREATE = \
79         scripts \
80         $(APIDOC_DIR) \
81         $(APIDOC_PY_DIR) \
82         $(APIDOC_HS_DIR) \
83         $(APIDOC_HS_DIR)/Ganeti $(APIDOC_HS_DIR)/Ganeti/HTools \
84         $(COVERAGE_DIR) \
85         $(COVERAGE_PY_DIR) \
86         $(COVERAGE_HS_DIR) \
87         .hpc
88
89 BUILDTIME_DIRS = \
90         $(BUILDTIME_DIR_AUTOCREATE) \
91         doc/html
92
93 DIRCHECK_EXCLUDE = \
94         $(BUILDTIME_DIRS) \
95         ganeti-[0-9]*.[0-9]*.[0-9]* \
96         doc/html/_*
97
98 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
99
100 # some helper vars
101 COVERAGE_DIR = doc/coverage
102 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
103 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
104 APIDOC_DIR = doc/api
105 APIDOC_PY_DIR = $(APIDOC_DIR)/py
106 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
107
108 MAINTAINERCLEANFILES = \
109         $(docpng) \
110         $(maninput) \
111         doc/install-quick.rst \
112         doc/news.rst \
113         doc/upgrade.rst \
114         vcs-version
115
116 maintainer-clean-local:
117         rm -rf $(BUILDTIME_DIRS)
118
119 CLEANFILES = \
120         $(addsuffix /*.py[co],$(DIRS)) \
121         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
122         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
123         $(all_dirfiles) \
124         $(PYTHON_BOOTSTRAP) \
125         epydoc.conf \
126         autotools/replace_vars.sed \
127         daemons/daemon-util \
128         daemons/ganeti-cleaner \
129         devel/upload \
130         doc/examples/bash_completion \
131         doc/examples/ganeti.initd \
132         doc/examples/ganeti-kvm-poweroff.initd \
133         doc/examples/ganeti.cron \
134         doc/examples/gnt-config-backup \
135         doc/examples/hooks/ipsec \
136         $(man_MANS) \
137         $(manhtml) \
138         tools/kvm-ifup \
139         stamp-srclinks \
140         $(nodist_pkgpython_PYTHON) \
141         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
142         .hpc/*.mix htools/*.tix \
143         doc/hs-lint.html
144
145 # BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
146 # it'll cause the target to rebuild every time.
147 BUILT_SOURCES = \
148         ganeti \
149         stamp-srclinks \
150         lib/_autoconf.py \
151         $(all_dirfiles) \
152         $(PYTHON_BOOTSTRAP)
153
154 nodist_pkgpython_PYTHON = \
155         lib/_autoconf.py
156
157 noinst_PYTHON = \
158         lib/build/__init__.py \
159         lib/build/sphinx_ext.py
160
161 pkgpython_PYTHON = \
162         lib/__init__.py \
163         lib/asyncnotifier.py \
164         lib/backend.py \
165         lib/bdev.py \
166         lib/bootstrap.py \
167         lib/cli.py \
168         lib/cmdlib.py \
169         lib/compat.py \
170         lib/config.py \
171         lib/constants.py \
172         lib/daemon.py \
173         lib/errors.py \
174         lib/ht.py \
175         lib/jqueue.py \
176         lib/jstore.py \
177         lib/locking.py \
178         lib/luxi.py \
179         lib/mcpu.py \
180         lib/netutils.py \
181         lib/objects.py \
182         lib/opcodes.py \
183         lib/qlang.py \
184         lib/query.py \
185         lib/rpc.py \
186         lib/runtime.py \
187         lib/serializer.py \
188         lib/ssconf.py \
189         lib/ssh.py \
190         lib/storage.py \
191         lib/uidpool.py \
192         lib/workerpool.py
193
194 client_PYTHON = \
195         lib/client/__init__.py \
196         lib/client/gnt_backup.py \
197         lib/client/gnt_cluster.py \
198         lib/client/gnt_debug.py \
199         lib/client/gnt_group.py \
200         lib/client/gnt_instance.py \
201         lib/client/gnt_job.py \
202         lib/client/gnt_node.py \
203         lib/client/gnt_os.py
204
205 hypervisor_PYTHON = \
206         lib/hypervisor/__init__.py \
207         lib/hypervisor/hv_base.py \
208         lib/hypervisor/hv_chroot.py \
209         lib/hypervisor/hv_fake.py \
210         lib/hypervisor/hv_kvm.py \
211         lib/hypervisor/hv_lxc.py \
212         lib/hypervisor/hv_xen.py
213
214 rapi_PYTHON = \
215         lib/rapi/__init__.py \
216         lib/rapi/baserlib.py \
217         lib/rapi/client.py \
218         lib/rapi/client_utils.py \
219         lib/rapi/connector.py \
220         lib/rapi/rlib2.py
221
222 http_PYTHON = \
223         lib/http/__init__.py \
224         lib/http/auth.py \
225         lib/http/client.py \
226         lib/http/server.py
227
228 confd_PYTHON = \
229         lib/confd/__init__.py \
230         lib/confd/client.py \
231         lib/confd/querylib.py \
232         lib/confd/server.py
233
234 masterd_PYTHON = \
235         lib/masterd/__init__.py \
236         lib/masterd/instance.py
237
238 impexpd_PYTHON = \
239         lib/impexpd/__init__.py
240
241 watcher_PYTHON = \
242         lib/watcher/__init__.py
243
244 server_PYTHON = \
245         lib/server/__init__.py \
246         lib/server/confd.py \
247         lib/server/masterd.py \
248         lib/server/noded.py \
249         lib/server/rapi.py
250
251 pytools_PYTHON = \
252         lib/tools/__init__.py \
253         lib/tools/ensure_dirs.py
254
255 utils_PYTHON = \
256         lib/utils/__init__.py \
257         lib/utils/algo.py \
258         lib/utils/filelock.py \
259         lib/utils/hash.py \
260         lib/utils/io.py \
261         lib/utils/log.py \
262         lib/utils/mlock.py \
263         lib/utils/nodesetup.py \
264         lib/utils/process.py \
265         lib/utils/retry.py \
266         lib/utils/text.py \
267         lib/utils/wrapper.py \
268         lib/utils/x509.py
269
270 docrst = \
271         doc/admin.rst \
272         doc/design-2.0.rst \
273         doc/design-2.1.rst \
274         doc/design-2.2.rst \
275         doc/design-2.3.rst \
276         doc/design-htools-2.3.rst \
277         doc/design-2.4.rst \
278         doc/design-draft.rst \
279         doc/design-oob.rst \
280         doc/design-query2.rst \
281         doc/design-x509-ca.rst \
282         doc/design-http-server.rst \
283         doc/design-impexp2.rst \
284         doc/design-lu-generated-jobs.rst \
285         doc/design-multi-reloc.rst \
286         doc/cluster-merge.rst \
287         doc/design-shared-storage.rst \
288         doc/devnotes.rst \
289         doc/glossary.rst \
290         doc/hooks.rst \
291         doc/iallocator.rst \
292         doc/index.rst \
293         doc/install-quick.rst \
294         doc/install.rst \
295         doc/locking.rst \
296         doc/move-instance.rst \
297         doc/news.rst \
298         doc/rapi.rst \
299         doc/security.rst \
300         doc/upgrade.rst \
301         doc/walkthrough.rst
302
303 HS_PROGS = \
304         htools/hbal \
305         htools/hscan \
306         htools/hail \
307         htools/hspace
308
309 HS_ALL_PROGS = $(HS_PROGS) htools/test
310 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
311 # we don't add -Werror by default
312 HFLAGS = -O -Wall -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
313 # extra flags that can be overriden on the command line
314 HEXTRA =
315 # exclude options for coverage reports
316 HPCEXCL = --exclude Main --exclude Ganeti.HTools.QC
317
318 HS_LIB_SRCS = \
319         htools/Ganeti/HTools/CLI.hs \
320         htools/Ganeti/HTools/Cluster.hs \
321         htools/Ganeti/HTools/Container.hs \
322         htools/Ganeti/HTools/ExtLoader.hs \
323         htools/Ganeti/HTools/Group.hs \
324         htools/Ganeti/HTools/IAlloc.hs \
325         htools/Ganeti/HTools/Instance.hs \
326         htools/Ganeti/HTools/Loader.hs \
327         htools/Ganeti/HTools/Luxi.hs \
328         htools/Ganeti/HTools/Node.hs \
329         htools/Ganeti/HTools/PeerMap.hs \
330         htools/Ganeti/HTools/QC.hs \
331         htools/Ganeti/HTools/Rapi.hs \
332         htools/Ganeti/HTools/Simu.hs \
333         htools/Ganeti/HTools/Text.hs \
334         htools/Ganeti/HTools/Types.hs \
335         htools/Ganeti/HTools/Utils.hs \
336         htools/Ganeti/Jobs.hs \
337         htools/Ganeti/Luxi.hs \
338         htools/Ganeti/OpCodes.hs
339
340 HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs
341 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
342
343 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
344
345 # Note: we use here an order-only prerequisite, as the contents of
346 # _autoconf.py are not actually influencing the html build output: it
347 # has to exist in order for the sphinx module to be loaded
348 # successfully, but we certainly don't want the docs to be rebuilt if
349 # it changes
350 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
351         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py lib/opcodes.py lib/ht.py \
352         | lib/_autoconf.py
353         @test -n "$(SPHINX)" || \
354             { echo 'sphinx-build' not found during configure; exit 1; }
355         @mkdir_p@ $(dir $@)
356         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
357             -d . \
358             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
359             -D release="$(PACKAGE_VERSION)" \
360             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
361         rm -f doc/html/.buildinfo doc/html/objects.inv
362         touch $@
363
364 doc/html: doc/html/index.html
365
366 doc/install-quick.rst: INSTALL
367 doc/news.rst: NEWS
368 doc/upgrade.rst: UPGRADE
369
370 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
371         set -e; \
372         { echo '.. This file is automatically updated at build time from $<.'; \
373           echo '.. Do not edit.'; \
374           echo; \
375           cat $<; \
376         } > $@
377
378 docdot = \
379         doc/arch-2.0.dot \
380         doc/design-2.1-lock-acquire.dot \
381         doc/design-2.1-lock-release.dot
382
383 docpng = $(patsubst %.dot,%.png,$(docdot))
384
385 # Things to build but not to install (add it to EXTRA_DIST if it should be
386 # distributed)
387 noinst_DATA = \
388         devel/upload \
389         doc/html \
390         doc/examples/bash_completion \
391         doc/examples/ganeti.cron \
392         doc/examples/ganeti.initd \
393         doc/examples/ganeti-kvm-poweroff.initd \
394         doc/examples/gnt-config-backup \
395         doc/examples/hooks/ipsec \
396         $(manhtml)
397
398 gnt_scripts = \
399         scripts/gnt-backup \
400         scripts/gnt-cluster \
401         scripts/gnt-debug \
402         scripts/gnt-group \
403         scripts/gnt-instance \
404         scripts/gnt-job \
405         scripts/gnt-node \
406         scripts/gnt-os
407
408 PYTHON_BOOTSTRAP_SBIN = \
409         daemons/ganeti-confd \
410         daemons/ganeti-masterd \
411         daemons/ganeti-noded \
412         daemons/ganeti-watcher \
413         daemons/ganeti-rapi \
414         scripts/gnt-backup \
415         scripts/gnt-cluster \
416         scripts/gnt-debug \
417         scripts/gnt-group \
418         scripts/gnt-instance \
419         scripts/gnt-job \
420         scripts/gnt-node \
421         scripts/gnt-os
422
423 PYTHON_BOOTSTRAP = \
424         $(PYTHON_BOOTSTRAP_SBIN) \
425         tools/ensure-dirs
426
427 qa_scripts = \
428         qa/ganeti-qa.py \
429         qa/qa_cluster.py \
430         qa/qa_config.py \
431         qa/qa_daemon.py \
432         qa/qa_env.py \
433         qa/qa_error.py \
434         qa/qa_instance.py \
435         qa/qa_node.py \
436         qa/qa_os.py \
437         qa/qa_rapi.py \
438         qa/qa_tags.py \
439         qa/qa_utils.py
440
441 bin_SCRIPTS =
442 iallocators_SCRIPTS =
443 if WANT_HTOOLS
444 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
445 iallocators_SCRIPTS += $(filter htools/hail,$(HS_PROGS))
446 endif
447
448 $(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
449         BINARY=$(@:htools/%=%); \
450         if [ "$$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
451           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
452           exit 1; \
453         fi; \
454         $(GHC) --make \
455           $(HFLAGS) $(HEXTRA) $(HTOOLS_NOCURL) \
456           -osuf $$BINARY.o -hisuf $$BINARY.hi \
457           $@
458
459 # for the htools/test binary, we need to enable profiling/coverage
460 htools/test: HEXTRA=-fhpc -Wwarn -fno-warn-missing-signatures \
461         -fno-warn-monomorphism-restriction -fno-warn-orphans \
462         -fno-warn-missing-methods -fno-warn-unused-imports
463
464 dist_sbin_SCRIPTS = \
465         tools/ganeti-listrunner
466
467 nodist_sbin_SCRIPTS = \
468         $(PYTHON_BOOTSTRAP_SBIN) \
469         daemons/ganeti-cleaner
470
471 dist_tools_SCRIPTS = \
472         tools/burnin \
473         tools/cfgshell \
474         tools/cfgupgrade \
475         tools/cfgupgrade12 \
476         tools/cluster-merge \
477         tools/lvmstrap \
478         tools/move-instance \
479         tools/setup-ssh \
480         tools/sanitize-config
481
482 pkglib_python_scripts = \
483         daemons/import-export \
484         tools/check-cert-expired
485
486 nodist_pkglib_python_scripts = \
487         tools/ensure-dirs
488
489 pkglib_SCRIPTS = \
490         daemons/daemon-util \
491         tools/kvm-ifup \
492         $(pkglib_python_scripts)
493
494 nodist_pkglib_SCRIPTS = \
495         $(nodist_pkglib_python_scripts)
496
497 EXTRA_DIST = \
498         NEWS \
499         UPGRADE \
500         epydoc.conf.in \
501         pylintrc \
502         autotools/build-bash-completion \
503         autotools/check-python-code \
504         autotools/check-man \
505         autotools/check-news \
506         autotools/check-tar \
507         autotools/check-version \
508         autotools/docpp \
509         autotools/gen-coverage \
510         autotools/testrunner \
511         $(RUN_IN_TEMPDIR) \
512         daemons/daemon-util.in \
513         daemons/ganeti-cleaner.in \
514         $(pkglib_python_scripts) \
515         devel/upload.in \
516         tools/kvm-ifup.in \
517         $(docdot) \
518         $(docpng) \
519         $(docrst) \
520         doc/conf.py \
521         doc/html \
522         doc/examples/ganeti.initd.in \
523         doc/examples/ganeti-kvm-poweroff.initd.in \
524         doc/examples/ganeti.cron.in \
525         doc/examples/gnt-config-backup.in \
526         doc/examples/ganeti.default \
527         doc/examples/ganeti.default-debug \
528         doc/examples/hooks/ethers \
529         doc/examples/hooks/ipsec.in \
530         doc/examples/gnt-debug/README \
531         doc/examples/gnt-debug/delay0.json \
532         doc/examples/gnt-debug/delay50.json \
533         test/testutils.py \
534         test/mocks.py \
535         $(dist_TESTS) \
536         $(TEST_FILES) \
537         man/footer.rst \
538         $(manrst) \
539         $(maninput) \
540         qa/qa-sample.json \
541         $(qa_scripts) \
542         $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
543         $(HS_PROG_SRCS)
544
545 man_MANS = \
546         man/ganeti.7 \
547         man/ganeti-cleaner.8 \
548         man/ganeti-confd.8 \
549         man/ganeti-listrunner.8 \
550         man/ganeti-masterd.8 \
551         man/ganeti-noded.8 \
552         man/ganeti-os-interface.7 \
553         man/ganeti-rapi.8 \
554         man/ganeti-watcher.8 \
555         man/gnt-backup.8 \
556         man/gnt-cluster.8 \
557         man/gnt-debug.8 \
558         man/gnt-group.8 \
559         man/gnt-instance.8 \
560         man/gnt-job.8 \
561         man/gnt-node.8 \
562         man/gnt-os.8 \
563         man/hail.1 \
564         man/hbal.1 \
565         man/hscan.1 \
566         man/hspace.1
567
568 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
569 manhtml = $(patsubst %.rst,%.html,$(manrst))
570 mangen = $(patsubst %.rst,%.gen,$(manrst))
571 maninput = \
572         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
573         $(patsubst %.html,%.html.in,$(manhtml)) \
574         man/footer.man man/footer.html $(mangen)
575
576 TEST_FILES = \
577         test/data/bdev-drbd-8.0.txt \
578         test/data/bdev-drbd-8.3.txt \
579         test/data/bdev-drbd-disk.txt \
580         test/data/bdev-drbd-net-ip4.txt \
581         test/data/bdev-drbd-net-ip6.txt \
582         test/data/cert1.pem \
583         test/data/proc_drbd8.txt \
584         test/data/proc_drbd80-emptyline.txt \
585         test/data/proc_drbd83.txt \
586         test/data/sys_drbd_usermode_helper.txt \
587         test/import-export_unittest-helper
588
589 python_tests = \
590         test/ganeti.asyncnotifier_unittest.py \
591         test/ganeti.backend_unittest.py \
592         test/ganeti.bdev_unittest.py \
593         test/ganeti.cli_unittest.py \
594         test/ganeti.client.gnt_cluster_unittest.py \
595         test/ganeti.client.gnt_instance_unittest.py \
596         test/ganeti.daemon_unittest.py \
597         test/ganeti.cmdlib_unittest.py \
598         test/ganeti.compat_unittest.py \
599         test/ganeti.confd.client_unittest.py \
600         test/ganeti.config_unittest.py \
601         test/ganeti.constants_unittest.py \
602         test/ganeti.errors_unittest.py \
603         test/ganeti.hooks_unittest.py \
604         test/ganeti.ht_unittest.py \
605         test/ganeti.http_unittest.py \
606         test/ganeti.hypervisor_unittest.py \
607         test/ganeti.hypervisor.hv_chroot_unittest.py \
608         test/ganeti.hypervisor.hv_fake_unittest.py \
609         test/ganeti.hypervisor.hv_kvm_unittest.py \
610         test/ganeti.hypervisor.hv_lxc_unittest.py \
611         test/ganeti.hypervisor.hv_xen_unittest.py \
612         test/ganeti.impexpd_unittest.py \
613         test/ganeti.jqueue_unittest.py \
614         test/ganeti.locking_unittest.py \
615         test/ganeti.luxi_unittest.py \
616         test/ganeti.masterd.instance_unittest.py \
617         test/ganeti.mcpu_unittest.py \
618         test/ganeti.netutils_unittest.py \
619         test/ganeti.objects_unittest.py \
620         test/ganeti.opcodes_unittest.py \
621         test/ganeti.qlang_unittest.py \
622         test/ganeti.query_unittest.py \
623         test/ganeti.rapi.baserlib_unittest.py \
624         test/ganeti.rapi.client_unittest.py \
625         test/ganeti.rapi.resources_unittest.py \
626         test/ganeti.rapi.rlib2_unittest.py \
627         test/ganeti.rpc_unittest.py \
628         test/ganeti.runtime_unittest.py \
629         test/ganeti.serializer_unittest.py \
630         test/ganeti.ssh_unittest.py \
631         test/ganeti.tools.ensure_dirs_unittest.py \
632         test/ganeti.uidpool_unittest.py \
633         test/ganeti.utils.algo_unittest.py \
634         test/ganeti.utils.filelock_unittest.py \
635         test/ganeti.utils.hash_unittest.py \
636         test/ganeti.utils.io_unittest.py \
637         test/ganeti.utils.log_unittest.py \
638         test/ganeti.utils.mlock_unittest.py \
639         test/ganeti.utils.nodesetup_unittest.py \
640         test/ganeti.utils.process_unittest.py \
641         test/ganeti.utils.retry_unittest.py \
642         test/ganeti.utils.text_unittest.py \
643         test/ganeti.utils.wrapper_unittest.py \
644         test/ganeti.utils.x509_unittest.py \
645         test/ganeti.utils_unittest.py \
646         test/ganeti.workerpool_unittest.py \
647         test/cfgupgrade_unittest.py \
648         test/docs_unittest.py \
649         test/tempfile_fork_unittest.py
650
651 haskell_tests = htools/test
652
653 dist_TESTS = \
654         test/check-cert-expired_unittest.bash \
655         test/daemon-util_unittest.bash \
656         test/ganeti-cleaner_unittest.bash \
657         test/import-export_unittest.bash \
658         $(python_tests)
659
660 nodist_TESTS =
661 if WANT_HTOOLS
662 nodist_TESTS += $(haskell_tests)
663 endif
664
665 TESTS = $(dist_TESTS) $(nodist_TESTS)
666
667 # Environment for all tests
668 PLAIN_TESTS_ENVIRONMENT = \
669         PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) $(RUN_IN_TEMPDIR)
670
671 # Environment for tests run by automake
672 TESTS_ENVIRONMENT = \
673         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
674
675 all_python_code = \
676         $(dist_sbin_SCRIPTS) \
677         $(dist_tools_SCRIPTS) \
678         $(pkglib_python_scripts) \
679         $(nodist_pkglib_python_scripts) \
680         $(python_tests) \
681         $(pkgpython_PYTHON) \
682         $(client_PYTHON) \
683         $(hypervisor_PYTHON) \
684         $(rapi_PYTHON) \
685         $(server_PYTHON) \
686         $(pytools_PYTHON) \
687         $(http_PYTHON) \
688         $(confd_PYTHON) \
689         $(masterd_PYTHON) \
690         $(impexpd_PYTHON) \
691         $(utils_PYTHON) \
692         $(watcher_PYTHON) \
693         $(noinst_PYTHON) \
694         $(qa_scripts)
695
696 srclink_files = \
697         man/footer.rst \
698         test/check-cert-expired_unittest.bash \
699         test/daemon-util_unittest.bash \
700         test/ganeti-cleaner_unittest.bash \
701         test/import-export_unittest.bash \
702         $(all_python_code) \
703         $(HS_LIB_SRCS) $(HS_PROG_SRCS)
704
705 check_python_code = \
706         $(BUILD_BASH_COMPLETION) \
707         $(DOCPP) \
708         $(all_python_code)
709
710 lint_python_code = \
711         ganeti \
712         ganeti/http/server.py \
713         $(dist_sbin_SCRIPTS) \
714         $(dist_tools_SCRIPTS) \
715         $(pkglib_python_scripts) \
716         $(BUILD_BASH_COMPLETION) \
717         $(DOCPP) \
718         $(PYTHON_BOOTSTRAP)
719
720 test/daemon-util_unittest.bash: daemons/daemon-util
721
722 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
723
724 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
725         sed -f $(REPLACE_VARS_SED) < $< > $@
726         chmod +x $@
727
728 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
729         sed -f $(REPLACE_VARS_SED) < $< > $@
730         chmod u+x $@
731
732 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
733         sed -f $(REPLACE_VARS_SED) < $< > $@
734         chmod +x $@
735
736 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
737         sed -f $(REPLACE_VARS_SED) < $< > $@
738
739 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
740         sed -f $(REPLACE_VARS_SED) < $< > $@
741
742 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
743         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
744         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
745
746 doc/%.png: doc/%.dot
747         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
748         $(DOT) -Tpng -o $@ $<
749
750 man/footer.man: man/footer.rst
751         @test -n "$(PANDOC)" || \
752           { echo 'pandoc' not found during configure; exit 1; }
753         $(PANDOC) -f rst -t man -o $@ $<
754
755 man/footer.html: man/footer.rst
756         @test -n "$(PANDOC)" || \
757           { echo 'pandoc' not found during configure; exit 1; }
758         $(PANDOC) -f rst -t html -o $@ $<
759
760 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py
761         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
762
763 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
764         @test -n "$(PANDOC)" || \
765           { echo 'pandoc' not found during configure; exit 1; }
766         set -o pipefail ; \
767         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
768           sed -e 's/\\@/@/g' > $@
769         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN) $@; fi
770
771 man/%.html.in: man/%.gen man/footer.html
772         @test -n "$(PANDOC)" || \
773           { echo 'pandoc' not found during configure; exit 1; }
774         set -o pipefail ; \
775         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
776           sed -e 's/\\@/@/g' > $@
777
778 man/%.1: man/%.1.in $(REPLACE_VARS_SED)
779         sed -f $(REPLACE_VARS_SED) < $< > $@
780
781 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
782         sed -f $(REPLACE_VARS_SED) < $< > $@
783
784 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
785         sed -f $(REPLACE_VARS_SED) < $< > $@
786
787 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
788         sed -f $(REPLACE_VARS_SED) < $< > $@
789
790 epydoc.conf: epydoc.conf.in Makefile
791         sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
792
793 vcs-version:
794         if test -d .git; then \
795           git describe > $@; \
796         elif test ! -f $@ ; then \
797           echo "Cannot auto-generate $@ file"; exit 1; \
798         fi
799
800 .PHONY: regen-vcs-version
801 regen-vcs-version:
802         set -e; \
803         cd $(srcdir); \
804         if test -d .git; then \
805           rm -f vcs-version; \
806           $(MAKE) vcs-version; \
807         fi
808
809 htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
810         set -e; \
811         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
812         sed -e "s/%ver%/$$VCSVER/" < $< > $@
813
814 lib/_autoconf.py: Makefile vcs-version | lib/.dir
815         set -e; \
816         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
817         { echo '# This file is automatically generated, do not edit!'; \
818           echo '#'; \
819           echo ''; \
820           echo '"""Build-time configuration for Ganeti.'; \
821           echo '';\
822           echo 'This file is autogenerated by the build process.'; \
823           echo 'For any changes you need to re-run ./configure (and'; \
824           echo 'not edit by hand).'; \
825           echo ''; \
826           echo '"""'; \
827           echo ''; \
828           echo '# pylint: disable-msg=C0301,C0324'; \
829           echo '# because this is autogenerated, we do not want'; \
830           echo '# style warnings' ; \
831           echo ''; \
832           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
833           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
834           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
835           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
836           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
837           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
838           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
839           echo "SYSCONFDIR = '$(sysconfdir)'"; \
840           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
841           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
842           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
843           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
844           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
845           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
846           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
847           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
848           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
849           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
850           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
851           echo "KVM_PATH = '$(KVM_PATH)'"; \
852           echo "SOCAT_PATH = '$(SOCAT)'"; \
853           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
854           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
855           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
856           echo "TOOLSDIR = '$(toolsdir)'"; \
857           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
858           echo "PKGLIBDIR = '$(pkglibdir)'"; \
859           echo "DRBD_BARRIERS = $(DRBD_BARRIERS)"; \
860           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
861           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
862           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
863           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
864           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
865           echo "RAPI_USER = '$(RAPI_USER)'"; \
866           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
867           echo "CONFD_USER = '$(CONFD_USER)'"; \
868           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
869           echo "NODED_USER = '$(NODED_USER)'"; \
870           echo "VCS_VERSION = '$$VCSVER'"; \
871           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
872         } > $@
873
874 $(REPLACE_VARS_SED): Makefile
875         set -e; \
876         { echo 's#@PREFIX@#$(prefix)#g'; \
877           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
878           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
879           echo 's#@BINDIR@#$(bindir)#g'; \
880           echo 's#@SBINDIR@#$(sbindir)#g'; \
881           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
882           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
883           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
884           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
885           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
886           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
887           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
888           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
889           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
890           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
891           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
892           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
893           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
894           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
895           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
896           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
897           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
898           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
899         } > $@
900
901 # Using deferred evaluation
902 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
903 daemons/ganeti-watcher: MODULE = ganeti.watcher
904 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
905 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
906
907 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
908         test -n "$(MODULE)" || { echo Missing module; exit 1; }
909         set -e; \
910         { echo '#!/usr/bin/python'; \
911           echo '# This file is automatically generated, do not edit!'; \
912           echo "# Edit $(MODULE) instead."; \
913           echo; \
914           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
915           echo; \
916           echo '# pylint: disable-msg=C0103'; \
917           echo '# C0103: Invalid name'; \
918           echo; \
919           echo 'import sys'; \
920           echo 'import $(MODULE) as main'; \
921           echo; \
922           echo '# Temporarily alias commands until bash completion'; \
923           echo '# generator is changed'; \
924           echo 'if hasattr(main, "commands"):'; \
925                 echo '  commands = main.commands # pylint: disable-msg=E1101'; \
926           echo; \
927           echo 'if __name__ == "__main__":'; \
928           echo '  sys.exit(main.Main())'; \
929         } > $@
930         chmod u+x $@
931
932 # We need to create symlinks because "make distcheck" will not install Python
933 # files when building.
934 stamp-srclinks: Makefile | $(all_dirfiles)
935         set -e; \
936         for i in $(srclink_files); do \
937                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
938                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
939                 fi; \
940         done
941         touch $@
942
943 .PHONY: ganeti
944 ganeti:
945         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
946
947 .PHONY: check-dirs
948 check-dirs: $(BUILT_SOURCES)
949         @set -e; \
950         find . -type d \( \( -name . \) -o \( \
951                 -name .git -o \
952                 -name autom4te.cache \
953                 \) -prune -o -print \) | { \
954                 error=; \
955                 while read dir; do \
956                         case "$$dir" in \
957                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
958                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
959                         esac; \
960                 done; \
961                 for dir in $(DIRS); do \
962                         if ! test -d "$$dir"; then \
963                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
964                                 error=1; \
965                         fi \
966                 done; \
967                 if test -n "$$error"; then exit 1; else exit 0; fi; \
968         }
969
970 check-local: check-dirs
971         $(CHECK_PYTHON_CODE) $(check_python_code)
972         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
973         $(CHECK_NEWS) < $(top_srcdir)/NEWS
974
975 .PHONY: lint
976 lint: $(BUILT_SOURCES)
977         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
978         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
979         cd $(top_srcdir)/qa && \
980           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
981           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
982
983 .PHONY: hlint
984 hlint: $(HS_BUILT_SRCS)
985         if tty -s; then C="-c"; else C=""; fi; \
986         hlint --report=doc/hs-lint.html $$C htools
987
988 # a dist hook rule for updating the vcs-version file; this is
989 # hardcoded due to where it needs to build the file...
990 dist-hook:
991         $(MAKE) regen-vcs-version && \
992         rm -f $(top_distdir)/vcs-version && \
993         cp -p $(srcdir)/vcs-version $(top_distdir)
994
995 # a distcheck hook rule for catching revision control directories
996 distcheck-hook:
997         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
998                 echo "Found revision control files in final archive." 1>&2; \
999                 exit 1; \
1000         fi
1001         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1002                 echo "Found Python byte code in final archive." 1>&2; \
1003                 exit 1; \
1004         fi
1005         if find $(top_distdir) -name '*~' | grep .; then \
1006                 echo "Found backup files in final archive." 1>&2; \
1007                 exit 1; \
1008         fi
1009 # Empty files or directories should not be distributed. They can cause
1010 # unnecessary warnings for packagers. Directories used by automake during
1011 # distcheck must be excluded.
1012         if find $(top_distdir) -empty -and -not \( \
1013                         -path $(top_distdir)/_build -or \
1014                         -path $(top_distdir)/_inst \) | grep .; then \
1015                 echo "Found empty files or directories in final archive." 1>&2; \
1016                 exit 1; \
1017         fi
1018         if test -n "$(BUILD_RELEASE)" && \
1019            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1020                 echo "Found unreleased version in NEWS." >&2; \
1021                 exit 1; \
1022         fi
1023
1024 # When building a release, stricter checks should be used
1025 distcheck-release dist-release: export BUILD_RELEASE = 1
1026 distcheck-release: distcheck
1027
1028 dist-release: dist
1029         set -e; \
1030         for i in $(DIST_ARCHIVES); do \
1031                 echo -n "Checking $$i ... "; \
1032                 autotools/check-tar < $$i; \
1033                 echo OK; \
1034         done
1035
1036 install-exec-local:
1037         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1038           "$(DESTDIR)${localstatedir}/log/ganeti" \
1039           "$(DESTDIR)${localstatedir}/run/ganeti"
1040
1041 # To avoid conflicts between directory names and other targets, a file inside
1042 # the directory is used to ensure its existence.
1043 %.dir:
1044         @mkdir_p@ $* && touch $@
1045
1046 .PHONY: apidoc
1047 if WANT_HTOOLSAPIDOC
1048 apidoc: py-apidoc hs-apidoc
1049 else
1050 apidoc: py-apidoc
1051 endif
1052
1053 .PHONY: py-apidoc
1054 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1055         $(RUN_IN_TEMPDIR) epydoc -v \
1056                 --conf $(CURDIR)/epydoc.conf \
1057                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1058
1059 .PHONY: hs-apidoc
1060 hs-apidoc: $(HS_BUILT_SRCS)
1061         @test -n "$(HSCOLOUR)" || \
1062             { echo 'HsColour' not found during configure; exit 1; }
1063         @test -n "$(HADDOCK)" || \
1064             { echo 'haddock' not found during configure; exit 1; }
1065         rm -rf $(APIDOC_HS_DIR)/*
1066         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools
1067         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1068         ln -s ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1069         set -e ; \
1070         cd htools; \
1071         if [ "$(HTOOLS_NOCURL)" ]; \
1072         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1073         else OPTGHC=""; \
1074         fi; \
1075         RELSRCS="$(HS_LIB_SRCS:htools/%=%)"; \
1076         for file in $$RELSRCS; do \
1077                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1078                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1079         done ; \
1080         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1081                 -t ganeti-htools -p haddock-prologue \
1082                 --source-module="%{MODULE/.//}.html" \
1083                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1084                 $$OPTGHC \
1085                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1086
1087 .PHONY: TAGS
1088 TAGS: $(BUILT_SOURCES)
1089         rm -f TAGS
1090         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1091           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1092           -path './qa/*.py' | \
1093           etags -l python -
1094
1095 .PHONY: coverage
1096 if WANT_HTOOLS
1097 coverage: py-coverage hs-coverage
1098 else
1099 coverage: py-coverage
1100 endif
1101
1102 .PHONY: py-coverage
1103 py-coverage: $(BUILT_SOURCES) $(python_tests)
1104         set -e; \
1105         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1106         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1107         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1108         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1109         $(python_tests)
1110
1111 .PHONY: hs-coverage
1112 hs-coverage: $(haskell_tests)
1113         cd htools && rm -f *.tix *.mix && ./test
1114         mkdir -p $(COVERAGE_HS_DIR)
1115         hpc markup --destdir=$(COVERAGE_HS_DIR) htools/test $(HPCEXCL)
1116         hpc report htools/test $(HPCEXCL)
1117         ln -s hpc_index.html $(COVERAGE_HS_DIR)/index.html
1118
1119 # Special "kind-of-QA" target for htools, needs special setup (all
1120 # tools compiled with -fhpc)
1121 .PHONY: live-test
1122 live-test: all
1123         set -e ; \
1124         cd htools; \
1125         rm -f .hpc; ln -s ../.hpc .hpc; \
1126         rm -f *.tix *.mix; \
1127         ./live-test.sh; \
1128         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1129           --output=live-test.tix ; \
1130         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1131         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1132                 --srcdir=.. $(HPCEXCL) ; \
1133         hpc report --srcdir=.. live-test $(HPCEXCL)
1134
1135 commit-check: distcheck lint apidoc
1136
1137 -include ./Makefile.local
1138
1139 # vim: set noet :